﻿Imports System.Data.OleDb

'------------------------------------------------------------------------------
' Module principal de la solution AGGCS ("Application Graphique de Gestion
' de Club Sportif") avec les fonctions et procédures suivantes:
' -SQLQuery
' -SQLNonQuery
' -SQLScalarQuery
' -GetActivityIdent
' -GetActivities
' -CheckActivity
' -AddActivity
' -DeleteActivity
' -GetMembers

Module MainAGGCS
    'BDD
    Dim base As String = "clubSportif.accdb"
    Dim connectionString As String = "Provider = Microsoft.ACE.OLEDB.12.0 ; Data source = " & base
	
    'Fonctions
    Public Function SQLQuery(ByVal query As String) As OleDbDataReader
        Try
            Dim connection As OleDbConnection = New OleDbConnection(connectionString)
            Dim sqlcommand = New OleDbCommand(query)
            sqlcommand.Connection() = connection
            connection.Open()
            Dim dataReader As OleDbDataReader = sqlcommand.ExecuteReader()
            Return dataReader
            dataReader.Close()
            connection.Close()
        Catch ex As OleDbException
            MsgBox("Erreur lors de l'exécution de la requête SQL")
            Return Nothing
        End Try
    End Function

    Public Sub SQLNonQuery(ByVal instruction As String)
        Try
            Dim connection As OleDbConnection = New OleDbConnection(connectionString)
            Dim sqlcommand = New OleDbCommand(instruction)
            sqlcommand.Connection() = connection
            connection.Open()
            sqlcommand.ExecuteNonQuery()
            connection.Close()
        Catch ex As OleDbException
            MsgBox("Erreur lors de l'exécution de l'instruction SQL")
        End Try
    End Sub

    Public Function SQLScalarQuery(ByVal instruction As String) As Integer
        Try
            Dim connection As OleDbConnection = New OleDbConnection(connectionString)
            Dim sqlcommand = New OleDbCommand(instruction)
            Dim output As Integer = 0
            sqlcommand.Connection() = connection
            connection.Open()
            output = sqlcommand.ExecuteScalar()
            Return output
            connection.Close()
        Catch ex As OleDbException
            MsgBox("Erreur lors de l'exécution de l'instruction SQL")
            Return Nothing
        End Try
    End Function

    Public Function GetActivityIdent(ByVal name As String) As String
        name = name.ToLower()
        Dim ident As Char() = {"A", "B", "C"}
        For i = 0 To 2
            ident(i) = name(i)
        Next
        ident.ToString()
        Return ident
    End Function

    Public Function GetActivities() As OleDbDataReader
        Return SQLQuery("SELECT nomActivite FROM Activite")
    End Function

    Public Function CheckActivity(ByVal ident As String) As Boolean
        Try
            If SQLScalarQuery("SELECT COUNT(codeActivite) FROM Activite WHERE codeActivite='" & ident & "'") <> 0 Then
                Return True
            Else
                Return False
            End If
        Catch ex As Exception
            MsgBox("Erreur pendant la recherche")
            Return Nothing
        End Try
    End Function

    Public Sub AddActivity(ByVal name As String)
        If CheckActivity(GetActivityIdent(name)) = False Then
            SQLNonQuery("INSERT INTO Activite (codeActivite, nomActivite) VALUES('" & GetActivityIdent(name) & "', '" & name & "')")
        Else
            MsgBox("Ajout impossible: l'activité existe déjà")
        End If
    End Sub

    Public Sub DeleteActivity(ByVal name As String)
        SQLNonQuery("DELETE FROM Activite WHERE codeActivite='" & GetActivityIdent(name) & "'")
    End Sub

    Public Function GetMembers() As OleDbDataReader
        Return SQLQuery("SELECT nomAdh, prenomAdh FROM Adherent")
    End Function

    Public Sub UpdateMember(ByVal ident As Integer, ByVal name As String, ByVal surname As String, ByVal dateOfBirth As String, ByVal telephone As String, ByVal mail As String, ByVal city As String)
        MsgBox("UPDATE Adherent SET numAdh=" & ident & ", nomAdh='" & name & "', prenomAdh='" & surname & "', telAdh='" & telephone & "', mailAdh='" & mail & "', dateNaissAdh='" & dateOfBirth & "', codeVille='" & city & "', WHERE numAdh=" & ident)
        SQLNonQuery("UPDATE Adherent SET numAdh=" & ident & ", nomAdh='" & name & "', prenomAdh='" & surname & "', telAdh='" & telephone & "', mailAdh='" & mail & "', dateNaissAdh='" & dateOfBirth & "', codeVille='" & city & "', WHERE numAdh=" & ident)
    End Sub

    Public Sub AddMember(ByVal ident As Integer, ByVal name As String, ByVal surname As String, ByVal dateOfBirth As String, ByVal telephone As String, ByVal mail As String, ByVal city As String)
        MsgBox("INSERT INTO Adherent (numAdh, nomAdh, prenomAdh, telAdh, mailAdh, dateNaissAdh, dateInsc1, codeVille) VALUES(" & ident & ", '" & name & "', '" & surname & "', '" & telephone & "', '" & mail & "', '" & dateOfBirth & "', '" & DateString.Replace("-", "/") & "', '" & city & "')")
        SQLNonQuery("INSERT INTO Adherent (numAdh, nomAdh, prenomAdh, telAdh, mailAdh, dateNaissAdh, dateInsc1, codeVille) VALUES(" & ident & ", '" & name & "', '" & surname & "', '" & telephone & "', '" & mail & "', '" & dateOfBirth & "', '" & DateString.Replace("-", "/") & "', '" & city & "')")
    End Sub

    Public Sub DeleteMember(ByVal ident As Integer)
        SQLNonQuery("DELETE FROM Adherent WHERE numAdh=" & ident)
    End Sub
End Module
